<template>

    <div class="gerar grey lighten-5">

        <loading :active.sync="isLoading" :can-cancel="true" :is-full-page="fullPage"></loading>

        <v-container class="" v-if="!isLoading">
            <v-row justify="center" no-gutters>
                <v-col md="auto">
                    <v-card class="pa-2" outlined tile>
                        <TipoProdutos :tiposProdutos='tiposProdutos' :produtos='produtos' />
                    </v-card>
                </v-col>
                <v-col md="auto">
                    <v-card class="pa-2" outlined tile>
                        <QuantidadeProdutos :cestinha='cestinha' :produtos='produtos'
                            :numeroUltimoPedido='numeroUltimoPedido' />
                    </v-card>
                </v-col>
                <v-col md="auto">
                    <v-card class="pa-2" outlined tile>
                        <Checkout :carrinho="carrinho" :tiposProdutos="tiposProdutos" :pedidos="produtos"
                            :valorTotal="valorTotal" :formasPagamento="formasPagamento" :valorTroco="valorTroco"
                            :valorDesconto="valorDesconto" />
                    </v-card>
                </v-col>
            </v-row>
        </v-container>

        <v-img src="../assets/persona.png" width="30px" @click="confirmarNomeCaixaDialog = true"></v-img> {{nomeCaixa}}

        <!-- NOME CAIXA -->
        <v-dialog v-model="confirmarNomeCaixaDialog" max-width="390">
            <v-card>
                <v-card-title class="headline">Informe o nome do Caixa</v-card-title>

                <v-card-text>
                    <v-text-field label="Nome do Caixa" placeholder="Nome do Caixa" outlined dense v-model="nomeCaixa">
                    </v-text-field>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>

                    <v-btn color="red darken-1" text @click="confirmarNomeCaixaDialog = false">
                        Cancelar
                    </v-btn>

                    <v-btn color="green darken-1" text @click="confirmaNomeCaixa(nomeCaixa)">
                        Confirmar
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <!-- SUCESSO PEDIDO -->
        <v-dialog class="green" v-model="sucessoPedidoModal" width="590">
            <v-card class="text-center center" align="center" justify="center" style="padding-top: 15px;">
                <br><br>
                <v-card-text align="center" justify="center">
                    <v-img src="../assets/success1.png" max-width="300px"></v-img>
                </v-card-text>

                <v-card-text align="center" justify="center">
                    <p>{{pedido.message}}</p>
                    <p>{{car.message}}</p>

                    <p>Pedido:</p>
                    <p style="font-size:70px;padding-bottom:10px;">{{zerosEsquerda(pedido.dados.id)}}</p>
                    <v-btn @click="proximoPedido()">Próximo Pedido</v-btn>
                </v-card-text>

            </v-card>
        </v-dialog>



    </div>
</template>

<style lang="scss">
    .lista-sem-formatacao ul {
        list-style-type: none;
        margin-left: 0 !important;
        padding: 0;
    }

    .lista-sem-formatacao li {
        margin: 0;
        padding: 0 0 10px;
        cursor: pointer;
    }

    .v-application ul {
        padding-left: 3px !important;
    }

    .v-card--reveal {
        align-items: center;
        bottom: 0;
        justify-content: center;
        opacity: .5;
        position: absolute;
        width: 100%;
    }

    .big-font {
        font-size: 90px;
    }

    .padding15 {
        padding: 15px;
    }
</style>

<script>
    // @ is an alias to /src
    import TipoProdutos from '@/components/Gerar/TipoProdutos.vue'
    import QuantidadeProdutos from '@/components/Gerar/QuantidadeProdutos.vue'
    import Checkout from '@/components/Gerar/Checkout.vue'
    import axios from 'axios';

    // Import Loading
    import Loading from 'vue-loading-overlay';
    import 'vue-loading-overlay/dist/vue-loading.css';

    axios.interceptors.response.use(
        function (response) {
            return response;
        },
        function (error) {
            console.log("error.response", error.response);
            return error.response;
        }
    );

    export default {
        name: 'Gerar',
        provide() {
            return {
                removerItemCarrinho: this.removerItemCarrinho,
                confirmarPedido: this.confirmarPedido,
                getNomeCaixa: this.getNomeCaixa,
                calculaTroco: this.calculaTroco,
                zerosEsquerda: this.zerosEsquerda,
            };
        },
        components: {
            QuantidadeProdutos,
            TipoProdutos,
            Loading,
            Checkout
        },
        data() {
            return {
                isLoading: false,
                fullPage: true,
                tiposProdutos: {
                    'dados': []
                },
                produtos: {
                    'dados': []
                },
                formaPagamento: {
                    'dados': []
                },
                formasPagamento: [],
                cestinha: {
                    'pedido_id': 0,
                    'produto_id': 0,
                    'tipo_produto_id': 0,
                    'quantidade': 0,
                    'valor': 0,
                    'observacao': '',
                },
                carrinho: [],
                soma: {
                    'dados': {}
                },
                valorTotal: 0,
                valorDesconto: 0,
                confirmarNomeCaixaDialog: false,
                nomeCaixa: '',
                valorTroco: 0,
                troco: {
                    'dados': {
                        troco: 0
                    }
                },
                numeroUltimoPedido: 0,
                sucessoPedidoModal: false,
                pedido: {
                    'dados': {
                        id: 0
                    },
                    'message': ''
                },
                car: {
                    'message': ''
                },
            }
        },
        created: function () {
            console.log("Gerar created");
            this.carregaTudo();
        },
        mounted: function () {
            console.log("Gerar mounted");
            this.carregaNomeCaixa();
        },
        methods: {
            carregaTudo: function () {
                let that = this;
                this.isLoading = true;

                this.carregaTiposProduto();
                this.carregaProdutos();
                this.carregaFormaPagamento();

                setTimeout(() => {
                    that.isLoading = false
                }, 3000);
            },
            carregaTiposProduto: async function () {
                console.log("Gerar carregaTiposProduto");
                let url = "http://localhost:8585/tipo_produto";

                await axios.get(url)
                    .then(response => {
                        this.tiposProdutos = null;
                        this.tiposProdutos = response.data;
                    })
                    .catch(error => this.erros = error.response);
            },
            carregaProdutos: function () {
                console.log("Gerar carregaProdutos");
                let url = "http://localhost:8585/produto";

                axios.get(url)
                    .then(response => {
                        this.produtos = response.data;
                    })
                    .catch(error => this.erros = error.response);
            },
            carregaFormaPagamento: function () {
                console.log("Gerar carregaFormaPagamento");
                let url = "http://localhost:8585/forma_pagamento";

                axios.get(url)
                    .then(response => {
                        this.formaPagamento = response.data;
                        this.arrumaFormasPagamento(this.formaPagamento);
                    })
                    .catch(error => this.erros = error.response);
            },
            informaSelecao: function (info) {
                console.log("Gerar informaSelecao", info);
                let prodSelect = this.produtos.dados.find(p => p.id === info);
                this.cestinha.quantidade = 0;
                this.cestinha.produto_id = info;
                this.cestinha.valor = prodSelect.valor;
                this.cestinha.tipo_produto_id = prodSelect.tipo_produto_id;
            },
            informaQuantidade: function (quantidade,observacao) {
                console.log("Gerar informaQuantidade", quantidade);
                this.cestinha.quantidade = quantidade;
                this.cestinha.observacao = observacao;

                this.carrinho.push({
                    'pedido_id': this.cestinha.pedido_id,
                    'produto_id': this.cestinha.produto_id,
                    'tipo_produto_id': this.cestinha.tipo_produto_id,
                    'quantidade': this.cestinha.quantidade,
                    'valor': this.cestinha.valor,
                    'observacao': this.cestinha.observacao
                });

                this.cestinha = {
                    'pedido_id': 0,
                    'produto_id': 0,
                    'tipo_produto_id': 0,
                    'quantidade': 0,
                    'valor': 0,
                    'observacao': ''
                };

                this.calculaCarrinho();
            },
            limpaCestinha: function () {
                console.log("TipoProdutos limpaCestinha");
                this.cestinha = {
                    'produto_id': 0,
                    'quantidade': 0
                };
            },
            retornaProdutos: function () {
                console.log("Gerar retornaProdutos");
                return this.produtos;
            },
            getNomeProduto: function (produto_id) {
                console.log("Gerar getNomeProduto", produto_id);
                let produts = {};

                if (produto_id != null && produto_id > 0 && this.produtos != undefined && this.produtos.dados
                    .length > 0) {

                    // produts = this.produtos.dados.filter(p => {
                    //     return p.id == produto_id
                    // });

                    produts = this.produtos.dados.find(p => p.id == produto_id);
                    return produts.nome;

                    // if (produts !== undefined && produts != null) {
                    //     return produts[0].nome;
                    // }
                }
                return '';
            },
            getImagemProduto: function (produto_id) {
                // console.log("Gerar getImagemProduto", produto_id);
                let produts = {};

                if (produto_id != null && produto_id > 0 && this.produtos != undefined && this.produtos.dados
                    .length > 0) {
                    produts = this.produtos.dados.filter(p => {
                        return p.id == produto_id
                    });
                    if (produts !== undefined && produts != null) {
                        return produts[0].imagem;
                    }
                }
                return '';
            },
            calculaCarrinho: function () {
                console.log("Gerar calculaCarrinho");
                let url = "http://localhost:8585/operacoes/soma";

                axios.post(url, this.carrinho)
                    .then(response => {
                        this.soma = response.data;
                        this.atualizaTotal(this.soma.dados.total_pedido);
                        this.atualizaDesconto(this.soma.dados.desconto);
                    })
                    .catch(error => this.erros = error.response);
            },
            calculaTroco: function (valorPedido, valorPago) {
                console.log("Gerar calculaTroco");
                let url = "http://localhost:8585/operacoes/troco";

                if (valorPago == 0) {
                    this.atualizaTroco(0);
                    return false;
                }

                axios.post(url, {
                        'pedido_id': 0,
                        'valor_pedido': valorPedido,
                        'valor_pago': valorPago
                    })
                    .then(response => {
                        this.troco = response.data;
                        this.atualizaTroco(this.troco.dados.troco);
                        console.log("troco na hora", this.troco.dados.troco);
                    })
                    .catch(error => this.erros = error.response);
            },
            atualizaTotal: function (valorTotal) {
                this.valorTotal = valorTotal;
                console.log("Gerar atualizaTotal", this.valorTotal);
            },
            atualizaDesconto: function (desconto) {
                console.log("Gerar atualizaDesconto", desconto);
                this.valorDesconto = desconto;
            },
            atualizaTroco: function (valorTroco) {
                if (valorTroco < 0)
                    valorTroco = 0;
                this.valorTroco = valorTroco;
                console.log("Gerar atualizaTroco", this.valorTroco);
                console.log("troco", this.troco);
            },
            getQuantidadeCestinha: function () {
                if (this.cestinha.quantidade == 0)
                    return '';
                return this.cestinha.quantidade;
            },
            removerItemCarrinho: function (index) {
                let carrinhoTemporario = this.carrinho;

                carrinhoTemporario.splice(index, 1);

                this.carrinho = carrinhoTemporario;

                this.calculaCarrinho();
            },
            carregaNomeCaixa: function () {
                this.nomeCaixa = localStorage.getItem('nome_caixa');
                if (this.nomeCaixa == undefined || this.nomeCaixa == null)
                    this.nomeCaixa = "";
            },
            getNomeCaixa: function () {
                console.log("Gerar getNomeCaixa", this.nomeCaixa);
                return this.nomeCaixa;
            },
            defineNomeCaixa: function (nome) {
                console.log("Gerar defineNomeCaixa", nome);
                localStorage.setItem('nome_caixa', nome);
            },
            confirmaNomeCaixa: function (nome) {
                console.log("Gerar confirmaNomeCaixa", nome);

                this.defineNomeCaixa(nome);
                this.confirmarNomeCaixaDialog = false;
            },
            arrumaFormasPagamento: function (formas) {
                console.log("Gerar arrumaFormasPagamento", formas);

                formas.dados.filter(f => {
                    this.formasPagamento.push({
                        'text': f.descricao,
                        'value': f.id
                    });
                });
            },
            confirmarPedido: function (pedidoFinal) {
                console.log("Gerar confirmarPedido", pedidoFinal);

                let url = "http://localhost:8585/pedido";
                let carrinhoPedido = [];

                axios.post(url, pedidoFinal)
                    .then(response => {
                        this.pedido = response.data;

                        console.log("pedido gerado", this.pedido);

                        this.carrinho.filter(c => {
                            c.pedido_id = this.pedido.dados.id;
                            carrinhoPedido.push(c);
                            return true;
                        });

                        this.carrinho = carrinhoPedido;
                        this.confirmarCarrinho(carrinhoPedido);
                    })
                    .catch(error => this.erros = error.response);
            },
            confirmarCarrinho: function (carrinhoPedido) {
                console.log("Gerar confirmarCarrinho", carrinhoPedido);
                let url = "http://localhost:8585/carrinho";

                axios.post(url, carrinhoPedido)
                    .then(response => {
                        this.car = response.data;
                        // this.sucessoPedido(this.car.dados);
                        this.pedido.carrinho = this.car;
                        this.sucessoPedido(this.pedido.dados);
                    })
                    .catch(error => this.erros = error.response);

            },
            sucessoPedido: function (pedido) {
                console.log("Gerar sucessoPedido", pedido);

                this.numeroUltimoPedido = pedido.id;
                this.sucessoPedidoModal = true;
            },
            proximoPedido: function () {
                console.log("Gerar proximoPedido");
                this.sucessoPedidoModal = false;

                this.carrinho = [];
                this.valorTotal = 0;
                this.valorDesconto = 0;
                this.valorTroco = 0;
                let tempFormas = this.formasPagamento;
                this.formasPagamento = [];
                this.formasPagamento = tempFormas;
            },
            zerosEsquerda: function (numero) {
                numero = numero.toString();
                while (numero.length < 4)
                    numero = "0" + numero;
                return numero;                
            },
        },
        computed: {

        },
    }
</script>